<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <b-breadcrumb :items="items"></b-breadcrumb>    
            <!-- Mask -->
        </base-header>
        <div class="container-fluid mt--7">
            <div class="row">
                <div class="col">
                    <div class="card shadow">
                        <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                            <h3 class="mb-0">
                                {{title}}
                            </h3>
                            <select name="list-app" v-model="listFloor" class="custom-select d-block w-100" @change="getFloor()">
                                <option v-for="(floor,index) in floorData" :key="index" :value="floor.floor">{{floor.floor}}</option>
                            </select>
                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                            </div>
                            <div class="col text-right">
                                <button class="btn btn-lg btn-primary" @click="showCreate = true">Create Room</button>
                            </div>
                            <div>
                                <modal :show="showCreate" @close="showCreate = false">
                                    <template slot="header">
                                        <h5 class="modal-title">Create</h5>
                                    </template>
                                    <div>
                                        <div class="col-lg-12">
                                            <base-input alternative=""
                                                        label="Buiding name"
                                                        placeholder="Buiding name"
                                                        input-classes="form-control-alternative"
                                                        v-model="room_name"
                                            />
                                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                                        </div>
                                    </div>
                                    <template slot="footer">
                                            <base-button type="secondary" @click="showCreate = false">Close</base-button>
                                            <base-button type="primary" @click="checkData">Create</base-button>
                                    </template>
                                </modal>
                            </div>
                        </div>
                        </div>

                        <div class="table-responsive">
                        <table class="table align-items-center table-flush text-center">
                            <tr>
                                <th>No.</th>
                                <th>Room name</th>
                                <th>Manage</th>
                            </tr>

                            <tr v-for="(room,index) in roomData" :key="room.all_id" :class="{editing: room == dataEdit}" v-cloak>
                            <td>{{index+1}}</td>
                            <td class="budget">
                                <div class="view">
                                <span>{{room.room}}</span>
                                <small @click="goEx(room.all_id)"><router-link class="text-blue" to="#"> example topic</router-link></small>
                                </div>
                                <div class="edit">
                                <base-input alternative=""
                                                    placeholder="App name"
                                                    input-classes="form-control-alternative"
                                                    v-model="room.room"
                                />
                                </div>
                            </td>
                            <td>
                                <div class="view">
                                    <span @click="editData(room)"><router-link class="text-primary" to="#"><i class="fas fa-pen"></i> Edit</router-link></span> |  
                                    <span @click="del(room)"><router-link class="text-danger" to="#"><i class="far fa-trash-alt"></i> Delete</router-link></span>
                                </div>
                                <div class="edit">
                                    <span @click="saveEdit(room)"><router-link class="text-success" to="#"><i class="fas fa-save"></i> Save</router-link></span> |  
                                    <span @click="cancelEdit()"><router-link class="text-default" to="#"><i class="far fa-window-close"></i> Cancel</router-link></span>
                                </div>
                            </td>

                            </tr>

                        </table>
                        </div>
                    </div>
                </div>
            </div>
    </div>
</div>
</template>
<script>

  export default {
    name: 'buiding-name',
    data() {
      return {
        title: 'Buiding name',
        floorData : [],
        roomData : [],
        message : '',
        error :'',
        room_name : '',
        showCreate : false,
        dataEdit : null,
        listFloor : '',
        items: [
          {
            text: 'Company',
            to: '/topic'
          },
          {
            text: 'App',
            to: '/app'
          },
          {
            text: 'Hotel',
            to: '/hotel'
          },
          {
            text: 'Buiding',
            to: '/buiding'
          },
          {
            text: 'Floor',
            to: '/floor'
          },
          {
            text: 'Room',
            active: true
          }
        ]
      }
    },
    created() {
        this.getDataFloor()
        this.getDataRoom()
    },
    methods: {
        getDataFloor(){
            this.error = ''
            this.$http.get('/manage/floor/'+localStorage.user_id+'/'+ localStorage.app_id+'/'+localStorage.hotel_id
            +'/'+localStorage.buiding)
            .then(response => {
                if(!response.data.message){
                    this.floorData = response.data
                    this.listFloor = localStorage.floor
                }else{
                    this.message = response.data.message
                }
          })
        },
        getDataRoom(){
            this.error = ''
            this.$http.get('/manage/room/'+localStorage.user_id+'/'+ localStorage.app_id+'/'+localStorage.hotel_id
            +'/'+localStorage.buiding+'/'+localStorage.floor)
            .then(response => {
                if(!response.data.message){
                    this.roomData = response.data
                }else{
                    this.message = response.data.message
                    this.roomData = []
                }
          })
        },
        checkData(){
            if(this.room_name === ''){
                this.error = 'Please enter room name'
            }else{
                this.sendCreate()
            }
        },
        sendCreate(){
            this.$http.post('/manage/room/create',{
                user_id : localStorage.user_id,
                app_id : localStorage.app_id,
                hotel_id : localStorage.hotel_id,
                buiding : localStorage.buiding,
                floor : localStorage.floor,
                room : this.room_name
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Created!",
                    icon: "success",
                    timer: 3000
                })
                this.getDataRoom()
                this.showCreate = false
                this.room_name = ''
                this.error = ''
              }else if(response.data.message === 'cant_create'){
                  this.error = 'Can not use this room name !!'
              }
          })
          .catch(() => this.checkCreateRoom())
        },
        checkCreateRoom(){
            this.error = 'Create failed!!'
        },
        editData(room){
            localStorage.all_id = room.all_id
            this.dataEdit = room
        },
        saveEdit(room){
            this.$swal({
                    title: "Confirm edit room name?",
                    icon: "warning",
                    buttons: ['cancel','confirm']
                })
                .then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/room/edit',{
                            user_id : localStorage.user_id,
                            app_id : localStorage.app_id,
                            hotel_id : localStorage.hotel_id,
                            room : room.room,
                            all_id : room.all_id
                        })
                        .then(response => {
                            if(response.data.message === 'cant_room'){
                                this.checkEditRoom()
                            }else if(response.data.message === 'success'){
                                this.$swal({
                                title: "Edited!",
                                icon: "success",
                                timer: 3000
                                })
                                this.getDataRoom()
                            }
                        })
                        .catch(() => this.checkEditRoom())
                    }
                })
        },
        cancelEdit(){
            this.dataEdit = null
            this.getDataRoom()
        },
        del(room){
                this.$swal({
                    title: "Confirm delete room name!!",
                    icon: "warning",
                    buttons: ['cancel','confirm'],
                    dangerMode: true
                }).then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/room/del',{
                            user_id : localStorage.user_id,
                            app_id : localStorage.app_id,
                            hotel_id : localStorage.hotel_id,
                            all_id : room.all_id
                        })
                        .then(response => {
                            if(response.data.message === 'success'){
                                this.$swal({
                                title: "Deleted!",
                                icon: "success",
                                timer: 3000
                                })
                            }
                            this.getDataRoom()
                        })
                        .catch(() => this.error = 'Delete failed!!' )
                    }
                })
        },
        checkEditRoom(){
            this.error = 'Edit failed!!'
        },
        getFloor(){
            localStorage.floor = this.listFloor
            this.getDataRoom()
        },
        goEx(all_id){
            this.$http.get('/manage/alltopic/gettopic_id/'+all_id)
            .then(response => {
            localStorage.topic_id = response.data.topic_id
            this.$router.push('/example')
          })
            
        }
    },
  };
</script>
<style scoped>
[v-cloak] {
      display: none;
    }
    .edit {
      display: none;
    }
    .editing .edit {
      display: block
    }
    .editing .view {
      display: none;
    }
</style>